ViewVC Help
View File | Revision Log | Show Annotations | Download File
/cvs/deliantra/server/utils/cfutil.in
(Generate patch)

Comparing deliantra/server/utils/cfutil.in (file contents):
Revision 1.39 by root, Sun Jul 15 22:39:48 2007 UTC vs.
Revision 1.52 by root, Sat Aug 18 22:25:35 2007 UTC

19use IO::AIO (); 19use IO::AIO ();
20use File::Temp; 20use File::Temp;
21use Crossfire; 21use Crossfire;
22use Coro; 22use Coro;
23use Coro::AIO; 23use Coro::AIO;
24use Coro::Util;
24use POSIX (); 25use POSIX ();
25use Digest::MD5; 26use Digest::MD5;
27use Carp;
26use Coro::Storable; $Storable::canonical = 1; 28use Coro::Storable; $Storable::canonical = 1;
29
30$SIG{QUIT} = sub { Carp::cluck "QUIT" };
27 31
28sub usage { 32sub usage {
29 warn <<EOF; 33 warn <<EOF;
30Usage: cfutil [-v] [-q] [--force] [--cache] 34Usage: cfutil [-v] [-q] [--force] [--cache]
31 [--install-arch path] 35 [--install-arch path]
92 if (!-f "$path/regions") { 96 if (!-f "$path/regions") {
93 warn "'$path' does not look like a maps directory ('regions' file is missing).\n"; 97 warn "'$path' does not look like a maps directory ('regions' file is missing).\n";
94 exit 1 unless $FORCE; 98 exit 1 unless $FORCE;
95 } 99 }
96 100
97 system $RSYNC, "-av", "$path/.", "$DATADIR/maps/.", "--delete", "--exclude", "CVS", "--delete-excluded" 101 system $RSYNC, "-a", "--chmod=u=rwX,go=rX", "$path/.", "$DATADIR/maps/.", "--delete", "--exclude", "CVS", "--delete-excluded"
98 and die "map installation failed.\n"; 102 and die "map installation failed.\n";
99 103
100 print "maps installed successfully.\n"; 104 print "maps installed successfully.\n";
101} 105}
102 106
167 # possibly enlarge 171 # possibly enlarge
168 if (0 > aio_stat "$stem.64x64.png") { 172 if (0 > aio_stat "$stem.64x64.png") {
169 my $other = "$stem.64x64.png~"; 173 my $other = "$stem.64x64.png~";
170 174
171 if (0 > aio_lstat $other or (-M _) > (-M $path)) { 175 if (0 > aio_lstat $other or (-M _) > (-M $path)) {
172 my $wrap = 0; # for the time being
173 fork_sub { 176 fork_sub {
177 my $CROP;
178 my $SRC = "png:\Q$path\E";
179
180 # check if this is a wall. ultra-ugly. ultra-ultra-ugly.
181 if ($path =~ /^(.*\/wall\/.*_)([0-9A-F])(\.x11.*\.png)$/) {
182 my ($pfx, $dir, $sfx) = ($1, hex $2, $3);
183 #check for 0..F images to be sure(?) this is a wall
184 unless (grep { !-e sprintf "%s%X%s", $pfx, $_, $sfx } 0..15) {
185 # add a 4px border and add other images around it
186 $CROP = "-shave 8x8 +repage";
187
188 $w += 8;
189 $h += 8;
190
191 $SRC = "-size ${w}x${h} xc:transparent";
192 $SRC .= " png:\Q$path\E -geometry +4+4 -composite";
193
194 # 8 surrounding images
195 for (
196 # x y b r0 r1
197 [-1, -1, 0, 6],
198 [ 0, -1, 1, 10, 14],
199 [+1, -1, 0, 12],
200
201 [-1, 0, 8, 5, 7],
202 #
203 [+1, 0, 2, 5, 13],
204
205 [-1, +1, 0, 3],
206 [ 0, +1, 4, 10, 11],
207 [+1, +1, 0, 9],
208 ) {
209 my ($x, $y, $d, $r0, $r1) = @$_;
210 $SRC .= sprintf " png:%s%X%s -geometry %+d%+d -composite",
211 "\Q$pfx",
212 ($dir & $d) ? $r1 : $r0,
213 "\Q$sfx",
214 $x * ($w - 8) + 4,
215 $y * ($h - 8) + 4;
216 }
217 }
218 }
219
174 system "convert png:\Q$path\E -depth 8 rgba:-" 220 system "convert -depth 8 $SRC rgba:-"
175 . "| $exec_prefix/bin/cfhq2xa $w $h $wrap" 221 . "| $exec_prefix/bin/cfhq2xa $w $h 0"
176 . "| convert -depth 8 -size ".($w * 2)."x".($h * 2)." rgba:- $QUANTIZE -quality 00 png32:\Q$other\E~" 222 . "| convert -depth 8 -size ".($w * 2)."x".($h * 2)." rgba:- $CROP $QUANTIZE -quality 00 png32:\Q$other\E~"
177 and die "convert/hq2xa pipeline error: status $? ($!)"; 223 and die "convert/cfhq2xa pipeline error: status $? ($!)";
178 system $OPTIPNG, "-i0", "-q", "$other~"; 224 system $OPTIPNG, "-i0", "-q", "$other~";
179 die "$other~ has zero size, aborting." unless -s "$other~"; 225 die "$other~ has zero size, aborting." unless -s "$other~";
180 rename "$other~", $other; 226 rename "$other~", $other;
181 }; 227 };
182 } 228 }
385 431
386 $TRS .= $trs; 432 $TRS .= $trs;
387 } 433 }
388 } 434 }
389 435
436 my %FILECACHE;
437
438 sub load_cached($;$) {
439 unless (exists $FILECACHE{$_[0]}) {
440 my $data;
441 if (0 < aio_load $_[0], $data) {
442 if ($_[1]) {
443 $data = eval { $_[1]->($data) };
444 warn "$_[0]: $@" if $@;
445 }
446 }
447
448 $FILECACHE{$_[0]} = $data;
449 }
450
451 $FILECACHE{$_[0]}
452 }
453
390 sub process_res { 454 sub process_res {
391 while (@res) { 455 while (@res) {
392 my ($dir, $file) = @{pop @res}; 456 my ($dir, $file, $type) = @{pop @res};
393 457
394 my $data; 458 my $data;
395 aio_load "$dir/$file", $data; 459 aio_load "$dir/$file", $data;
396 460
397 my $copyright; 461 my $meta = load_cached "$dir/meta", sub { JSON::XS::from_json shift };
398 aio_load "$dir/copyright", $copyright; 462
463 next if $meta && !exists $meta->{$file};
464
465 $meta = {
466 %{ $meta->{"" } || {} },
467 %{ $meta->{$file} || {} },
468 };
469
470 if ($meta->{license} =~ s/^#//) {
471 $meta->{license} = ({
472 "pd" => "Public Domain",
473 "gpl" => "GNU General Public License, version 3.0 or any later",
474 "cc/by/2.0" => "Licensed under Creative Commons Attribution 2.0 http://creativecommons.org/licenses/by/2.0/",
475 "cc/by/2.5" => "Licensed under Creative Commons Attribution 2.0 http://creativecommons.org/licenses/by/2.5/",
476 "cc/by/3.0" => "Licensed under Creative Commons Attribution 3.0 http://creativecommons.org/licenses/by/3.0/",
477 })->{$meta->{license}}
478 || warn "$dir/$file: license tag '$meta->{license}' not found.";
479 }
399 480
400 $file =~ s/\.res$//; 481 $file =~ s/\.res$//;
401 $file =~ /\.([^.]+)$/ 482 $file =~ s/\.(ogg|wav|jpg|png)$//;
402 or next;
403
404 my $type = $1;
405 483
406 substr $dir, 0, 1 + length $PATH, ""; 484 substr $dir, 0, 1 + length $PATH, "";
407 485
408 $RESOURCE{"$dir/$file"} = { 486 $RESOURCE{"$dir/$file"} = {
409 type => $1, 487 type => (delete $meta->{type}) || $type,
410 copyright => $copyright,
411 data => $data, 488 data => $data,
412 chksum => Digest::MD5::md5 $data, 489 chksum => (Digest::MD5::md5 $data),
490 %$meta ? (meta => $meta) : (),
413 }; 491 };
414 } 492 }
415 } 493 }
416 494
417 sub find_files; 495 sub find_files;
423 my ($dirs, $nondirs) = @_; 501 my ($dirs, $nondirs) = @_;
424 502
425 find_files "$path/$_" 503 find_files "$path/$_"
426 for grep $_ !~ /^(?:CVS|dev)$/, @$dirs; 504 for grep $_ !~ /^(?:CVS|dev)$/, @$dirs;
427 505
506 my $dir = $path;
507 substr $dir, 0, 1 + length $PATH, "";
508
428 for my $file (@$nondirs) { 509 for my $file (@$nondirs) {
510 if ($dir =~ /^music(?:\/|$)/) {
511 push @res, [$path, $file, 3] # FT_MUSIC
512 if $file =~ /\.(ogg)$/;
513
514 } elsif ($dir =~ /^sound(?:\/|$)/) {
515 push @res, [$path, $file, 5] # FT_SOUND
516 if $file =~ /\.(wav|ogg)$/;
517
518 } elsif ($dir =~ /^res(?:\/|$)/) {
519 push @res, [$path, $file, 0] # FT_FACE
520 if $file =~ /\.(jpg|png)$/;
521 push @res, [$path, $file, 7] # FT_RSRC
522 if $file =~ /\.(res)$/;
523
429 if ($file =~ /\.png$/) { 524 } elsif ($file =~ /\.png$/) {
430 push @png, ["$path/$file", 0]; 525 push @png, ["$path/$file", 0];
526
431 } elsif ($file =~ /\.trs$/) { 527 } elsif ($file =~ /\.trs$/) {
432 push @trs, [$path, $file]; 528 push @trs, [$path, $file];
529
433 } elsif ($file =~ /\.arc$/) { 530 } elsif ($file =~ /\.arc$/) {
434 push @arc, [$path, $file]; 531 push @arc, [$path, $file];
435 } elsif ($file =~ /\.(ogg|jpg|res)$/) { 532
436 push @res, [$path, $file];
437 } else { 533 } else {
438 warn "ignoring $path/$file\n" if $VERBOSE >= 3; 534 warn "ignoring $path/$file\n" if $VERBOSE >= 3;
439 } 535 }
440 } 536 }
441 }; 537 };

Diff Legend

Removed lines
+ Added lines
< Changed lines
> Changed lines